Subject: Re: [PATCH] log: decorate detached HEAD differently

From: Michael J Gruber <[email-masked]>
Date: Tue, 10 Mar 2015 11:34:56 +0100

Junio C Hamano venit, vidit, dixit 10.03.2015 03:03:
> Michael J Gruber <[email-masked]> writes:
> 
>> Junio C Hamano venit, vidit, dixit 06.03.2015 20:03:
>>> Michael J Gruber <[email-masked]> writes:
>>>>     
>>>>     Note that now a checked branch is listed twice, once as target of the
>>>>     HEAD, once as branch: They are two different refs and colored differently.
>>>
>>> The pointee of HEAD would always be branch and will always appear on
>>> the output when you show HEAD->$name_of_that_branch; is it feasible
>>> to drop the duplicate, I wonder?
>>
>> It's doable but not nice, because we cannot take the order in which refs
>> are processed for granted.
> 
> That is true, but when we format them into a single line in the
> header in response to --decorate (or %d), don't we have all of them
> already at hand---does the order still matter?
> 
> Here is an illustration of what I had in mind, made on a random
> commit I happened to have checked out that does not have your
> patches on this topic.  Half of the change is a new helper function,
> and the other half is mostly reindenting.

Yes, the patch illustrates pretty well what I meant by "doable but not
nice" :)

But I also said:

> Also, HEAD and foo are two different refs, so even if HEAD has the value
> "foo", I think we should really show them both anyways.
> 
> Alternatively, we could decorate by (HEAD, *foo, master, tag: release)
> if foo is checked out, just like branch does.

I guess I will have to apply your patch and feel what it's like in
practical use in order to change my mind...

Michael